package ogss;


import java.io.File;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class ParseFrame {
	String[] flag={"agt","exp","ins","obj","sour","goal","loc","time","pred","color","shape","container","attribute","loc_item"};
	int[] case_flag = new int[14];
	String[] sem = new String[14];
	ArrayList<String> itemDB = new ArrayList<String>();
	boolean flg=true;

	public class PhraseData{
		String phraseSemantic;
		String phraseCase;
		String phrase;

		public PhraseData(String phr,String phrSem,String phrCase){
			phrase = phr;
			phraseSemantic = phrSem;
			phraseCase = phrCase;

//			System.out.println("phrase:"+phrase+","+phraseSemantic+","+phraseCase);

		}
		public String getPhrase(){
			return phrase;
		}
		public String getPhraseSem(){
			return phraseSemantic;
		}
		public String getPhraseCase(){
			return phraseCase;
		}
	}

	public ArrayList<String> dataExtract(ArrayList<PhraseData> list,String extract){
		ArrayList<String> phraseList= new ArrayList<String>();
		if(extract.equals("phrase")){
			for(int i=0;i<list.size();i++){
				String phrase = (list.get(i)).getPhrase();
				phraseList.add(phrase);
			}
		}
		else if(extract.equals("phraseSem")){
			for(int i=0;i<list.size();i++){
				String phraseSem = (list.get(i)).getPhraseSem();
				phraseList.add(phraseSem);
			}
		}
		else if(extract.equals("phraseCase")){
			for(int i=0;i<list.size();i++){
				String phraseCase = (list.get(i)).getPhraseCase();
				phraseList.add(phraseCase);
			}
		}
		return phraseList;
	}

	public String parsing(String input) {
		String out="";
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("frame.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			String[] wordlist = input.split(" ");


			//pXy[X
			input = input.replace(" ","");
			//SpXy[X
			input = input.replace("@","");

			// semanticvf̃Xg擾

			NodeList frameList = root.getElementsByTagName("frame");
			NodeList caseList = null;
			itemDB = ParseVoca.containsVoca(input);

			for(int j=0;j<14;j++){
				case_flag[j]=-1;
			}

			// framevf̐[v
			for (int i=0; i < frameList.getLength() ; i++) {

				ArrayList<PhraseData> order = new ArrayList<PhraseData>();
				ArrayList<PhraseData> list = new ArrayList<PhraseData>();


				// framevf擾
				Element frameElement = (Element)frameList.item(i);
				// framee̒l擾
				String frameCase = frameElement.getAttribute("case");
				String frameSemantic = frameElement.getAttribute("semantic");
				String frameSemanticSub = frameElement.getAttribute("semanticSub");
				String frameSurface = frameElement.getAttribute("surface");
				String frameRequired = frameElement.getAttribute("required");
				String frameRequiredSub = frameElement.getAttribute("requiredSub");
				String frameRequiredSem = "";
				String frameRequiredSubSem = "";


				Pattern pattern2 = Pattern.compile("\\((.+)\\)");
				Matcher match1 = pattern2.matcher(frameSurface);

				String surf;
				if(match1.find()){
					surf = match1.group(1);
				}
				else{
					surf = frameSurface;
				}
				Pattern pattern1 = Pattern.compile("\\|");
				String[] surface = pattern1.split(surf);
				if(surface.length!=0){

					for(int k=0;k<surface.length;k++){
						//inputframehitꍇ

						if(input.indexOf(surface[k])!=-1 && case_flag[8]==-1){
							sem[8]=surface[k];
							case_flag[8]=1;
							list.add(new PhraseData(surface[k],frameSemantic,frameCase));

							// casevf̃Xg擾
							caseList = frameElement.getElementsByTagName("case");

							for (int j=0; j < caseList.getLength() ; j++) {
								// casevf擾

								Element caseElement = (Element)caseList.item(j);

								String caseCase = caseElement.getAttribute("case");
								String caseSemantic = caseElement.getAttribute("semantic");
								String caseMarker = caseElement.getAttribute("marker");
								int flag_no=-1;

								if(caseCase.equals(frameRequired)){
									frameRequiredSem = caseSemantic;
								}
								if(caseCase.equals(frameRequiredSub)){
									frameRequiredSubSem = caseSemantic;
								}

								for(int l=0;l<14;l++){
									if(flag[l].equals(caseCase)){
										flag_no=l;
									}
								}
								String marker=new String();

								if(flag_no!=-1){
									if(case_flag[flag_no]==-1){
										if(flag_no<13){
											marker = matching(caseSemantic,caseMarker,input,wordlist);
										}
										if(marker!=null){
											case_flag[flag_no]=1;
											sem[flag_no]=marker;
											list.add(new PhraseData(marker,caseSemantic,caseCase));
										}
									}
								}
							}
						}
					}

					if(case_flag[8]==1){
						ArrayList<String> listPhraseCase = new ArrayList<String>();
						listPhraseCase = dataExtract(list,"phraseCase");

						if(!listPhraseCase.contains(frameRequiredSub)){
							list.add(list.size(),new PhraseData("ModPro",frameRequiredSubSem,frameRequiredSub));
						}
						if(!listPhraseCase.contains(frameRequired)){
							list.add(list.size(),new PhraseData("ZeroPro",frameRequiredSem,frameRequired));
						}
						//o͐

						if(!list.isEmpty()){
							order = new ArrayList<PhraseData>(put_in_order(input,list));
						}
						if(!order.isEmpty()&&flg){
							out = output(order,frameSemanticSub);
						}

					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return out;
	}


//	(*)ɓK̂Amarkeror\œKȂ̂𒊏o
	public String matching(String frame_semantic,String marker,String input,String wordlist[]){

		String match_wild = "(*)";
		ArrayList<String> list = new ArrayList<String>();
		String item="";

		if(marker.indexOf(match_wild)!=-1){
			if(item!=null){
				item = ParseVoca.searching(frame_semantic,wordlist);
				list.add(item);
			}
			if(item!=null){
				marker = marker.replace("(*)",item);
			}
		}


		if(!marker.contains(match_wild)){
			if(marker.indexOf("|")!=-1){
//				or\̏
				Pattern pattern2 = Pattern.compile("\\((.+)\\)");

				String match = marker;
				Matcher match1 = pattern2.matcher(match);

				if(match1.find()){
					String tmp = match1.group(1);
					Matcher match2 = pattern2.matcher(tmp);

					while(match2.find()){
						String tmp_or = match2.group(1);
						marker = search_Candidature(marker,tmp_or,input);
						match2 = pattern2.matcher(marker);
					}
					marker = search_Candidature(marker,tmp,input);
				}
			}
		}
		if(input.indexOf(marker)!=-1){
		//marker̕sv
			if(marker.endsWith("ɂ")){
				marker = replaceLast(marker,"ɂ","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
			if(marker.endsWith("")){
				marker = replaceLast(marker,"","");
			}
				return marker;
		}

			return null;

	}


//	marker̍Ōɂregexreplacementɒu
	public String replaceLast(String marker,String regex,String replacement){
		int index = marker.lastIndexOf(regex);
		String firstHalf = marker.substring(0,index);
		String secondHalf = marker.substring(index);
		secondHalf = secondHalf.replace(regex,replacement);
		String ans = firstHalf.concat(secondHalf);
		return ans;

	}


//	or\琳̂𒊏o֐search_Candidature ( ŏƍŌ"("")"͎OɎ菜Ă  )
	public String search_Candidature(String marker,String tmp,String input){
		Pattern pattern = Pattern.compile("\\|");

		String[] candidature = pattern.split(tmp);
		for(int k=0;k<candidature.length;k++){
			//candidatureinputhitꍇ
			if(input.indexOf(candidature[k])!=-1){
				marker = marker.replace("("+tmp+")",candidature[k]);
				return marker;
			}
		}
		return marker;
	}


	//input̏ԂlistɓĂPׂȂ
	public ArrayList<PhraseData> put_in_order(String input,ArrayList<PhraseData> list){
		ArrayList<PhraseData> order = new ArrayList<PhraseData>();

		int count=0;

		if(!list.isEmpty()){
			for(int i=0;i<list.size();i++){

				if(((list.get(i)).getPhrase()).equals("ModPro")){
					order.add(0,new PhraseData((list.get(i)).getPhrase(),(list.get(i)).getPhraseSem(),(list.get(i)).getPhraseCase()));
					count++;
				}
				else if(((list.get(i)).getPhrase()).equals("ZeroPro")){
					order.add(1,new PhraseData((list.get(i)).getPhrase(),(list.get(i)).getPhraseSem(),(list.get(i)).getPhraseCase()));
					count++;
				}
				else if(((list.get(i)).getPhraseCase()).equals("predicate")){
					order.add(count,new PhraseData((list.get(i)).getPhrase(),(list.get(i)).getPhraseSem(),(list.get(i)).getPhraseCase()));
					count++;
				}
				else{
					for(int j=0;j<order.size();j++){
						if(input.indexOf((list.get(i)).getPhrase()) < input.indexOf((order.get(j)).getPhrase())){
							order.add(count-1,new PhraseData((list.get(i)).getPhrase(),(list.get(i)).getPhraseSem(),(list.get(i)).getPhraseCase()));
							count++;
							break;
						}
					}
				}
			}
		}
		return order;
	}


	public String output(ArrayList<PhraseData> list,String surface){
		StringBuffer line = new StringBuffer();
		int[] flag_output = new int[list.size()];
		for(int i=0;i<list.size();i++){
			flag_output[i]=0;
		}

		int index = search("predicate",list,flag_output);
		if(index!=-1){
			flag_output[index]=1;
//			2010/12/27 C iłȂӖo͂Ă̂
			line.append("[" + surface+"]");
		}
		if(line.length()==0)
			return "";

		index = search("obj",list,flag_output);

		if(index!=-1){
			flag_output[index]=1;
			String tmpCase="";
			//"obj"̒Ô̂tmpCaseɑ(W󂯂̍\)
			if(index>0){
				tmpCase = (list.get(index-1)).getPhraseCase();

				if(tmpCase.equals("loc")){
					line.insert(line.length()-1,",[" + (list.get(index-1)).getPhrase()+ "("+(list.get(index-1)).getPhraseSem()+"):" + (list.get(index-1)).getPhraseCase() +"<1.0>]");
					flag_output[index-1] = 1;
					int tmpI = line.indexOf((list.get(index-1)).getPhrase());
					line.insert(tmpI,"[" + (list.get(index)).getPhrase()+ "("+(list.get(index)).getPhraseSem()+"):" + (list.get(index)).getPhraseCase() +"<1.0>],");
				}
			}else{
				line.insert(line.length()-1,",[" + (list.get(index)).getPhrase()+ "("+(list.get(index)).getPhraseSem()+"):"  + (list.get(index)).getPhraseCase() +"<1.0>]");
			}
		}
		index = search("ins",list,flag_output);
		if(index!=-1){
			flag_output[index] = 1;
//			"ins"̒Ô̂tmpCaseɑ(W󂯂̍\)
			if(index>0){
				String tmpCase = (list.get(index-1)).getPhraseCase();
				if(tmpCase.equals("loc")&&index>0){
					line.insert(line.length()-1,",[" + (list.get(index-1)).getPhrase()+ "("+(list.get(index-1)).getPhraseSem()+"):" + (list.get(index-1)).getPhraseCase() +"<1.0>]");
					flag_output[index-1] = 1;
					int tmpI = line.indexOf((list.get(index-1)).getPhrase());
					line.insert(tmpI,"[" + (list.get(index)).getPhrase()+ "("+(list.get(index)).getPhraseSem()+"):" + (list.get(index)).getPhraseCase() +"<1.0>],");
				}
			}else{
				line.insert(line.length()-1,",[" + (list.get(index)).getPhrase()+ "("+(list.get(index)).getPhraseSem()+"):"  + (list.get(index)).getPhraseCase() +"<1.0>]");
			}
		}

		index = search("agt",list,flag_output);
		if(index!=-1){
			line.insert(line.length()-1,",[" + (list.get(index)).getPhrase()+ "("+(list.get(index)).getPhraseSem()+"):"  + (list.get(index)).getPhraseCase() +"<1.0>]");
			flag_output[index] = 1;
		}

		index = search("loc",list,flag_output);
		if(index!=-1){
			line.insert(line.length()-1,",[" + (list.get(index)).getPhrase() + "("+(list.get(index)).getPhraseSem()+"):"  + (list.get(index)).getPhraseCase() +"<1.0>]");
			flag_output[index] = 1;
		}

		index = search("goal",list,flag_output);
		if(index!=-1){
			line.insert(line.length()-1,",[" + (list.get(index)).getPhrase() + "("+(list.get(index)).getPhraseSem()+"):"  + (list.get(index)).getPhraseCase() +"<1.0>]");
			flag_output[index] = 1;
		}

		System.out.println(line);
		/*
		try{
			File file = new File("frameOutput.txt");
			FileWriter filewriter = new FileWriter(file,true);
			line.append("\r\n");
			filewriter.write(line.toString());
			filewriter.close();
		}catch(IOException e){
			e.printStackTrace();
		}*/
		line.append("\r\n");
		flg=false;
		String line2 = line.toString();
		return line2;
	}

	public int search(String searchCase,ArrayList<PhraseData> list,int[] flag_output){
		for(int i=0;i<list.size();i++){
			String phraseCase = (list.get(i)).getPhraseCase();
			if(phraseCase.equals(searchCase)){
				if(flag_output[i]!=1){
					return i;
				}
			}
		}
		return -1;
	}


}